<html>
  <head>
    <title>PHP Events Adminstration Page</title>
    <link rel="stylesheet" type="text/css" href="main.css">
    <script type="text/javascript">
      function submitForm(action, index, pagenum)
      {
      	document.getElementById("hdnAction").value=action;
      	document.getElementById("hdnIndex").value=index;
      	document.getElementById("hdnPagenum").value=pagenum;
      	document.forms[0].submit();
      }
    </script>

  </head>

  <body>
    <h1 style="text-align:center; font-size:12pt; font-weight:bold;">PHP Events Administration Page</h1>
    <div>
      This page allows you to add, edit and delete from the database.
      <ul>
        <li>
          To add an event, type the appropiate data into the fields in the green row at the bottom of the grid.  Click the save icon at the left side of the row to commit the changes to the database.
        </li>
        <li>
          To edit an event, click the pencil icon to the left of the row you wish to edit.  The page will refresh to display the current data in textbox fields.  Make the necessary changes in the textboxes.  Click the save icon at the left side of the row to commit the changes to the database.
        </li>
        <li>
          To delete an event, click the X icon to the left of the row you wish to delete.
        </li>
        <li>
          To commit changes, click the Save Change button as the bottom of the grid.
        </li>
        <li>
          <a target="new" href="calendar.htm">View the Calendar</a>
        </li>
      </ul>
    </div>


    <?php

// ********* ********* ********* ********* ********* 
// scriptcalendar.com
// ********* ********* ********* ********* ********* 
// THIS IS A PHP EXAMPLE OF A PAGE THAT RENDERS THE scevent.js
// OR MORE ACCURATELY, RENDERS THE fscEvent CALLS THAT COMPRISE THE scevent.js
// IT IS BENEFICIAL TO RENDER THE scevent.js ON DEMAND (VERY MUCH LIEK A WEB
// SERVICE) VERSUS SAVING A FILE TO THE SERVER.  IF YOU SAVE A FILE TO THE
// SERVER, YOU COULD ENCOUNTER FILE LOCKS WITH MULTIPLE CONCURRENT USERS

// THIS EXAMPLE USES AN XML DATA SOURCE, NAMELY THE scevent.xml FILE
// ********* ********* ********* ********* ********* 


include 'common.php'; 



/* check for parameters*/
$action = "";
if (isset($_POST['hdnAction'])) {
	$action = $_POST["hdnAction"];
}
$index = "";
if (isset($_POST['hdnIndex'])) {
	$index = $_POST["hdnIndex"];
}
$pagenum = 1;
if (isset($_POST['hdnPagenum'])) {
	$pagenum = $_POST["hdnPagenum"];
}
$pagesize = 20;


/* initialize and load the DOM */
$xmlDOM = new domDocument;
$xmlFile = "scevent.xml";
$xml = "";
if (isset($_POST['hdnXml'])) {
  $xml = $_POST["hdnXml"];
  $xml = urldecode($xml); 
  $xmlDOM->loadXML($xml);
}
if (strlen($xml)==0) {
	$xmlDOM->load($xmlFile);
}
if (!$xmlDOM) {
    echo 'Error while parsing the document';
    exit;
}
$xmlSimple = simplexml_import_dom($xmlDOM);



/* save posted data */
$errors = "";
if ($action=="save") {
	$errors = validateInput();
	if (strlen($errors)==0) {
		$xmlEvent = $xmlSimple->event[$index-1];
 		saveToXml($xmlEvent);
	}
}
if ($action=="add") {
	$errors = validateInput();
	if (strlen($errors)==0) {
		$xmlEvent = $xmlDOM->documentElement->getElementsByTagName('event')->item(0)->cloneNode(true);
		$xmlDOM->documentElement->appendChild($xmlEvent);
		$xmlSimple = simplexml_import_dom($xmlDOM);
		$xmlEvent = $xmlSimple->event[$index-1];
		saveToXml($xmlEvent);
	}
}
if ($action=="delete") {
	$xmlEvent = $xmlDOM->documentElement->getElementsByTagName('event')->item($index-1);
	$xmlDOM->documentElement->removeChild($xmlEvent);
	$xmlSimple = simplexml_import_dom($xmlDOM);
}
if ($action=="savexml") {
	$xml = $xmlSimple->asXML();
	saveXmlFile($xmlFile, $xml);
}


printf ("<p align='center' class='Error'>%s</p>", $errors);



/* begin table */
printf ("<form method='post'>\r\n");
printf ("<input type='hidden' id='hdnAction' name='hdnAction' value='%s'/>\r\n", $action);
printf ("<input type='hidden' id='hdnIndex' name='hdnIndex' value='%s'/>\r\n", $index);
printf ("<input type='hidden' id='hdnPagenum' name='hdnPagenum' value='%s'/>\r\n", $pagenum);
printf ("<input type='hidden' id='hdnXml' name='hdnXml' value=\"%s\"/>\r\n", urlencode($xmlSimple->asXML())); 

printf ("<table align='center' border='0' cellpadding='2' cellspacing='1'>\r\n");
printf ("<thead>\r\n");
printf ("<tr class='RowHeader'><th>#</th><th>Action</th><th>M</th><th>D</th><th>Y</th><th>Text</th><th>PopupLink</th><th>Style</th><th>Tooltip</th><th>Script</th><th>Filter</th></tr>\r\n");
printf ("</thead>\r\n");
printf ("<tbody>\r\n");

$pagestart=($pagenum-1)*$pagesize+1;
$pageend=$pagestart+$pagesize-1;

/* iterate event nodes */
$i=0;
foreach ($xmlSimple->event as $xmlEvent) {
	$i++;
	if ($i>=$pagestart && $i<=$pageend ) { 

		/* construct links */
		$editLink =   sprintf("<a href=\"javascript:submitForm('edit',   %s, %s);\"><img border='0' src='images/icon-edit.gif'/></a>",   $i, $pagenum);
		$saveLink =   sprintf("<a href=\"javascript:submitForm('save',   %s, %s);\"><img border='0' src='images/icon-save.gif'/></a>",   $i, $pagenum);
		$deleteLink = sprintf("<a href=\"javascript:submitForm('delete', %s, %s);\"><img border='0' src='images/icon-delete.gif'/></a>", $i, $pagenum);
		$cancelLink = sprintf("<a href=\"javascript:submitForm('cancel', %s, %s);\"><img border='0' src='images/icon-cancel.gif'/></a>", $i, $pagenum);
	

		/* output table row */
		if ($action == "edit" && $index == $i) {
	
			/* edit row */
			printf ("<tr class='RowYellow'>");
			printf ("<td align='center'>%s</td><td align='center'>%s %s</td>", $i, $saveLink, $cancelLink);
			printf ("<td><input type='textbox' id='txtMonth' name='txtMonth' value=\"%s\" size='2'/></td>", formatXmlData($xmlEvent->month, false, true, ""));
			printf ("<td><input type='textbox' id='txtDay' name='txtDay' value=\"%s\" size='2'/></td>", formatXmlData($xmlEvent->day, false, true, ""));
			printf ("<td><input type='textbox' id='txtYear' name='txtYear' value=\"%s\" size='2'/></td>", formatXmlData($xmlEvent->year, false, true, ""));
			printf ("<td><input type='textbox' id='txtText' name='txtText' value=\"%s\" size='40'/></td>", formatXmlData($xmlEvent->text, false, true, ""));
			printf ("<td><input type='textbox' id='txtPopuplink' name='txtPopuplink' value=\"%s\" size='30'/></td>", formatXmlData($xmlEvent->popuplink, false, true, ""));
			printf ("<td><input type='textbox' id='txtStyle' name='txtStyle' value=\"%s\" size='10'/></td>", formatXmlData($xmlEvent->style, false, true, ""));
			printf ("<td><input type='textbox' id='txtTooltip' name='txtTooltip' value=\"%s\" size='10'/></td>", formatXmlData($xmlEvent->tooltip, false, true, ""));
			printf ("<td><input type='textbox' id='txtScript' name='txtScript' value=\"%s\" size='10'/></td>", formatXmlData($xmlEvent->script, false, true, ""));
			printf ("<td><input type='textbox' id='txtFilter' name='txtFilter' value=\"%s\" size='10'/></td>", formatXmlData($xmlEvent->filter, false, true, ""));
			printf ("</tr>\r\n");

		}
		else {	

			/* view row */
			printf ("<tr class='RowGray'>");
			printf ("<td align='center'>%s</td><td align='center'>%s %s</td>", $i, $editLink, $deleteLink);
			printf ("<td>%s</td>", formatXmlData($xmlEvent->month, false, true, "&nbsp;"));
			printf ("<td>%s</td>", formatXmlData($xmlEvent->day, false, true, "&nbsp;"));
			printf ("<td>%s</td>", formatXmlData($xmlEvent->year, false, true, "&nbsp;"));
			printf ("<td>%s</td>", formatXmlData($xmlEvent->text, false, true, "&nbsp;"));
			printf ("<td>%s</td>", formatXmlData($xmlEvent->popuplink, false, true, "&nbsp;"));
			printf ("<td>%s</td>", formatXmlData($xmlEvent->style, false, true, "&nbsp;"));
			printf ("<td>%s</td>", formatXmlData($xmlEvent->tooltip, false, true, "&nbsp;"));
			printf ("<td>%s</td>", formatXmlData($xmlEvent->script, false, true, "&nbsp;"));
			printf ("<td>%s</td>", formatXmlData($xmlEvent->filter, false, true, "&nbsp;"));
			printf ("</tr>\r\n");

		}
	}
}



/* insert row */
$addLink = sprintf("<a href=\"javascript:submitForm('add',    %s, %s);\"><img border='0' src='images/icon-save.gif'/></a>",    $i+1, $pagenum);
$disabled = "";
if ($action == "edit") {
  $addLink = "&nbsp;";
  $disabled = "disabled='true'";
}
printf ("<tr class='RowGreen'>");
printf ("<td align='center'>&nbsp;</td><td align='center'>%s</td>", $addLink);
printf ("<td><input type='textbox' id='txtMonth' name='txtMonth' value='%s' size='2' %s/></td>", "", $disabled);
printf ("<td><input type='textbox' id='txtDay' name='txtDay' value='%s' size='2' %s/></td>", "", $disabled);
printf ("<td><input type='textbox' id='txtYear' name='txtYear' value='%s' size='2' %s/></td>", "", $disabled);
printf ("<td><input type='textbox' id='txtText' name='txtText' value='%s' size='40' %s/></td>", "", $disabled);
printf ("<td><input type='textbox' id='txtPopuplink' name='txtPopuplink' value='%s' size='30' %s/></td>", "", $disabled);
printf ("<td><input type='textbox' id='txtStyle' name='txtStyle' value='%s' size='10' %s/></td>", "", $disabled);
printf ("<td><input type='textbox' id='txtTooltip' name='txtTooltip' value='%s' size='10' %s/></td>", "", $disabled);
printf ("<td><input type='textbox' id='txtScript' name='txtScript' value='%s' size='10' %s/></td>", "", $disabled);
printf ("<td><input type='textbox' id='txtFilter' name='txtFilter' value='%s' size='10' %s/></td>", "", $disabled);
printf ("</tr>\r\n");


/* paging */
printf ("<tr>");
printf ("<td colspan='11' align='right'>page");
for ($j = 1; $j <= $i/$pagesize+0.99; $j++) {
	printf (" <a href=\"javascript:submitForm('',-1, %s);\">%s</a>", $j, $j);
}
printf ("</td>");
printf ("</tr>\r\n");


/* save button */
printf ("<tr>");
printf ("<td colspan='11' align='center'><br/><a class='button' href=\"javascript:submitForm('savexml',-1, %s);\">Save Changes</a></td>", $pagenum)
printf ("</tr>\r\n");



/* end table */
printf ("</tbody>\r\n");
printf ("</table>\r\n");
printf ("</form>\r\n");
printf ("<div style='height:1000px'>&nbsp;</div>\r\n");



/* validate user input */
function validateInput()
{
	$errors = "";

	$data = $_POST["txtMonth"];
	if (strlen($data)>0) {
		if (intval($data)<1 or intval($data)>12) {
			$errors = $errors."<br/>&#149; Month must be a numeric value between 1 and 12";
		}
	}

	$data = $_POST["txtYear"];
	if (strlen($data)>0) {
		if (intval($data)<2000 or intval($data)>2100) {
			$errors = $errors."<br/>&#149; Year must be a numeric value between 2000 and 2100";
		}
	}

	return $errors;
}



/* save user input to xml */
function saveToXml($xmlEvent)
{
  $xmlEvent->month = $_POST["txtMonth"];
  $xmlEvent->day = $_POST["txtDay"];
  $xmlEvent->year = $_POST["txtYear"];
  $xmlEvent->text = $_POST["txtText"];
  $xmlEvent->popuplink = $_POST["txtPopuplink"];
  $xmlEvent->style = $_POST["txtStyle"];
  $xmlEvent->tooltip = $_POST["txtTooltip"];
  $xmlEvent->script = $_POST["txtScript"];
  $xmlEvent->filter = $_POST["txtFilter"];    
}
?>


</body>
</html>